@EXIT	EQU	402DH
@ABORT	EQU	4030H
@ERROR	EQU	4409H
@DSPLY	EQU	4467H
@LOGOT	EQU	447BH
@CKDRV	EQU	44B8H
WRSECT	EQU	4763H
WRPROT	EQU	4768H
VERSEC	EQU	4772H
RDSECT	EQU	4777H
GETDCT	EQU	478FH
RDSSEC	EQU	4B45H
;
	ORG	5200H
;
START	PUSH	HL
	LD	HL,SPLASH
	CALL	@DSPLY
	POP	HL
SPACES	LD	A,(HL)
	INC	HL
	CP	' '
	JR	Z,SPACES	;skip all spaces
	CP	':'
	JP	NZ,NODRV	;must be ':'
	LD	A,(HL)
	SUB	'0'
	CP	08H
	JP	NC,NODRV	;not 0-7; is not a drive
;distribute the drive number
	LD	(DRVNO1),A
	LD	(DRVNO2),A
	LD	(DRVNO3),A
;point IY at DCT of drive
	LD	C,A
	CALL	GETDCT
;check for harddisk
	BIT	3,(IY+3)	;harddisk?
	JP	NZ,NOMINI
;check for 8"
	BIT	5,(IY+3)	;8" drive?
	JP	NZ,NOMINI
;check for disk presence and writeprotect status
	CALL	@CKDRV		;update DCT with disk data?
	LD	A,32		;reprt error with illegal dev
	JP	NZ,NOREADY	;illegal device
	JP	C,NOWRITE	;writeprotected
;check for single sided
	BIT	5,(IY+4)	;dual sided?
	JP	Z,NODS
;check for double density
	BIT	6,(IY+3)	;double density?
	JP	NZ,NOSD
;distribute the directory cylinder number
	LD	A,(IY+9)	;get directory cylinder
	LD	(DIRCYL1),A	;usually cyls/2
	LD	(DIRCYL2),A
;read entire dir into buffer
	LD	B,20		;20 sectors DIR on DSSD80
	LD	HL,BUFFER
	LD	DE,2800H
DIRCYL1	EQU	$-1		;D=dircyl
	LD	C,0
DRVNO1	EQU	$-1		;C=drive
DRLOOP	CALL	RDSSEC	;C=drv D=cyl E=sec=0 HL=buffer
	JP	NZ,NOREADY
	INC	E		;next sector
	INC	H		;HL+=100h
	DJNZ	DRLOOP
;check for LDOS 5.3.x
	LD	A,(BUFFER+0CBH)
	CP	53H
	JP	NZ,NOLDOS
;check for correctly placed SYS0/SYS direntry
	LD	B,11		;filename length
	LD	HL,BUFFER+405H	;addr reserved for SYS0/SYS
	LD	DE,FNAME
CPLOOP1	LD	A,(DE)
	CP	(HL)
	JP	NZ,NOSYS0
	INC	HL
	INC	DE
	DJNZ	CPLOOP1
;check placement of SYS0/SYS
	LD	HL,(BUFFER+416H)
	LD	A,H		;gran entry
	CP	3
	JR	Z,OVER1		;typical
	CP	1
	JP	NZ,NOLONG
	LD	A,(BUFFER+419H)	;next gran entry
	CP	1
	JP	Z,NOOVER
	JP	NOLONG
;
;the typical layout SYS0/SYS spread over 4 gran in 1 cyl
;we need to move gran 2 and 3 to side 0 next cylinder
OVER1	LD	A,L		;get the cylinder
	LD	(SYS0CYL),A	;store in retrieval
	INC	A		;new cylinder wanted
	LD	C,A		;keep for compare
	LD	HL,BUFFER	;point HL to GAT entry
	ADD	A,L		;HL=HL+A
	LD	L,A		;alligned buffer H is OK
	LD	A,(HL)		;get gat entry of new cyl
	AND	3		;gran 0 and 1 busy?
	JR	NZ,ISBUSY
;the needed space is free allocate it and relase previous
	LD	A,(HL)		;get GAT entry for new cyl
	OR	3		;allocate gran 0 and 1
	LD	(HL),A		;put back
	DEC	HL		;bump to original
	LD	A,(HL)		;get GAT for original cyl
	AND	0F3H		;deallocate gran 2 and 3
	LD	(HL),A		;put back
	LD	A,3EH		;LD A,n instruction
	LD	(WRGAT),A	;replace JR WR1ST with LD A
	JP	WRDIR		;go apply changes
;
;we must find out which file occupies area
ISBUSY	LD	HL,(BUFFER+200H);start of entries
	LD	B,0		;entry 0
	JR	DENTRY
;bump to next entry
DEBUMP	INC	B
	LD	A,B
	CP	144		;no of entries (DSSD)
	JP	Z,NOOWNER	;not found - bad GAT
	POP	HL
	LD	A,L
	ADD	A,20H
	LD	L,A
	JR	NC,DENTRY
	INC	H		;next sector of dir
;check this directory entry for a match on the cylinder
;the entry of extent should start here regardless since it
;is just after SYS0/SYS (typically SYS1/SYS start)
DENTRY	PUSH	HL		;save current entry addr
	BIT	4,(HL)		;active
	JR	Z,DEBUMP	;not active (killed)
	LD	A,L
	ADD	A,16H		;skip to 1st extent
	LD	L,A
	JR	NC,$+3
	INC	H		;buffer page bump
	LD	A,C		;nextcyl
	CP	(HL)		;cylinder?
	INC	HL		;don't affect Z flag
	JR	NZ,EXT2TST	;jump if no match
	LD	A,(HL)		;get entry extents
	AND	0E0H		;starting gran of extent?
	JR	Z,DFOUND
EXT2TST	INC	HL		;2nd extent
	CP	(HL)		;cylinder?
	INC	HL		;don't affect Z flag
	JR	NZ,EXT3TST	;jump if no match
	LD	A,(HL)		;get entry extents
	AND	0E0H		;starting gran of extent
	JR	Z,DFOUND
EXT3TST	INC	HL		;3rd extent
	CP	(HL)		;cylinder?
	INC	HL		;don't affect Z flag
	JR	NZ,EXT4TST	;jump if no match
	LD	A,(HL)		;get entry extents
	AND	0E0H		;starting gran of extent
	JR	Z,DFOUND
EXT4TST	INC	HL		;4th extent
	CP	(HL)		;cylinder?
	INC	HL		;don't affect Z flag
	JR	NZ,DEBUMP	;no match goto next dir entry
	LD	A,(HL)		;get entry extents
	AND	0E0H		;starting gran of extent
	JR	NZ,DEBUMP	;next directory entry
;this entry starts at needed place
DFOUND	LD	A,(HL)		;get entry gran extents again
	AND	1FH		;no of granules - 1
	CP	1		;2 granules?
	JR	C,ONLYONE	;only 1 granule
	JR	NZ,TAKETWO	;>2 split necessary
;the entry is 2 granules just move it (possibly SYS1/SYS)
;HL points to dir entrys's "offending" 2 gran extent's gran
;exent entry C is nextcyl the cylinder of this extent
;by changing this extent to point to the previous cyl
;extent gran 2 and 3 instead of 0 and 1
	SET	6,(HL)		;starting gran = 2 was 0
	DEC	HL
	DEC	(HL)		;cylinder -= 1
	POP	HL		;no more need to keep cur ent
;now we have to write back the changed sector if it is not
;the same as the SYS0/SYS entry
ADR2ND	LD	DE,BUFFER
	OR	A
	SBC	HL,DE
	LD	A,H		;sector
	LD	(SEC2ND),A	;put in writing routine
	LD	L,0		;start of sec
	ADD	HL,DE		;point to buffer cyl start
	LD	(BUF2ND),HL	;put in writing routine
	JR	WRDIR		;go apply changes
;
;the "offending" file is longer than 2 gran which means it
;has to be split
TAKETWO	JP	NOOWNER		;dummy errormessage
;
;the "offending" file has only one granule take it and check
;for the last granule
ONLYONE	JP	NOOWNER		;dummy errormessage
;
;Update the dir and swap data in one sweep operation
;some of the writes are conditional
WRDIR	LD	DE,2800H	;D=cyl=28h (default) E=sec=0
DIRCYL2	EQU	$-1		;D=dircyl
	LD	C,0		;C=drv=0 (default)
DRVNO2	EQU	$-1		;C=drive
;GAT write (done only if necessary - with JR mangled)
WRGAT	JR	WR1ST		;mangle to LD A,WR1ST-$+2
;update the GAT with the new data
	LD	HL,BUFFER	;write back changed GAT
	CALL	WRPROT		;C=drv D=cyl E=sec=0 HL=buffer
	CALL	Z,VERPROT	;C=drv D=cyl E=sec
	JP	NZ,NOREADY
;update SYS0/SYS' directory entry (allways done, allways same)
;keep C=drv D=cyl from previous
WR1ST	LD	HL,(BUFFER+416H)
	LD	H,1		;=gran 0 and 1, was gran 0-3
	LD	(BUFFER+416H),HL
	INC	L		;next cyl
	LD	(BUFFER+418H),HL
	LD	HL,BUFFER+400H	;4th sector
	LD	E,4		;4th sector
	CALL	WRPROT		;C=drv D=cyl E=sec=4 HL=buffer
	CALL	Z,VERPROT	;C=drv D=cyl E=sec
	JP	NZ,NOREADY
;update "offending" file directory entry
;(done only if SEC2ND is changed from 4)
;keep C=drv D=cyl from previous
WR2ND	LD	A,E		;A=4
	LD	E,4		;dummy argument
SEC2ND	EQU	$-1		;A is to contain the sector
	CP	E		;not set or 4 skip writing
	JR	Z,WRSWAP
	LD	HL,BUFFER+400H	;dummy argument
BUF2ND	EQU	$-2		;HL is to contain buffer addr
	CALL	WRPROT		;C=drv D=cyl E=sec HL=buffer
	CALL	Z,VERPROT	;C=drv D=cyl E=sec
	JP	NZ,NOREADY
;swap the data
;read all 20 sectors and write back swapped. swap gran 2 and
;3 from side 1 to next cyl side 0 gran 0 and 1
;read sys0 end from cyl x gran 2 and 3
WRSWAP	LD	HL,BUFFER	;to BUFFER
	LD	B,10		;10 sectors 2 granules
	LD	DE,010AH	;E=sec=10
SYS0CYL	EQU	$-1		;D=cyl=org
	LD	C,0
DRVNO3	EQU	$-1		;C=drive
SRLOOP	CALL	RDSECT		;C=drv D=cyl E=sec HL=buffer
	JP	NZ,NOREADY
	INC	E		;next sector
	INC	H		;next 100h
	DJNZ	SRLOOP
;read 2nd area from cyl x+1 gran 0 and 1 to BUFFER+A00
	LD	B,10		;10 sectors
	LD	E,0		;sec 0
	INC	D		;next cyl
ERLOOP	CALL	RDSECT		;C=drv D=cyl E=sec HL=buffer
	JP	NZ,NOREADY
	INC	E		;next sector
	INC	H		;next 100h
	DJNZ	ERLOOP
;write sys0 end to cyl x+1 gran 0 and 1
	LD	B,10		;10 sectors
	LD	H,.HIGH.BUFFER	;HL=BUFFER
	LD	E,0
SWLOOP	CALL	WRSECT		;C=drv D=cyl E=sec HL=buffer
	JP	NZ,NOREADY
	INC	E		;next sector
	INC	H		;next 100h
	DJNZ	SWLOOP
;write 2nd area to cyl x gran 2 and 3
	LD	B,E		;10 sectors
	DEC	D		;previus cyl
EWLOOP	CALL	WRSECT		;C=drv D=cyl E=sec HL=buffer
	JP	NZ,NOREADY
	INC	E		;next sector
	INC	H		;next 100h
	DJNZ	EWLOOP
;verify 2nd area in cyl x gran 2 and 3
	LD	B,10		;10 sectors
	LD	E,B		;sector 10
EVLOOP	CALL	VERSEC		;C=drv D=cyl E=sec
	JP	NZ,NOREADY
	INC	E		;next sector
	DJNZ	EVLOOP
;verify sys0 end in cyl x+1 gran 0 and 1
	LD	B,10		;10 sectors
	INC	D		;next cyl
	LD	E,0		;sector 0
SVLOOP	CALL	VERSEC		;C=drv D=cyl E=sec
	JP	NZ,NOREADY
	INC	E		;next sector
	DJNZ	SVLOOP
;all OK display message and exit
	LD	HL,RESULT	;OK
	CALL	@DSPLY
	LD	HL,0
	JP	@EXIT
;
VERPROT	CALL	VERSEC	;C=drv D=cyl E=sec
	JR	Z,VEROK	;no error
	SUB	6	;attempted to read system data record
	RET	Z	;ignore error 6 returning A=0 with Z
	ADD	A,6
	RET		;return with NZ and errno in A
VEROK	OR	1
	LD	A,0
	RET
;
;error handling
NOREADY	OR	40H	;flag 1 line errormessage
	JP	@ERROR
;
NOSD	LD	HL,ERRDD
	DB	22H		;mangle next
NODS	LD	HL,ERRDS
	DB	22H		;mangle next
NOWRITE	LD	HL,ERRWRT
	DB	22H		;mangle next
NOMINI	LD	HL,ERRMINI
	DB	22H		;mangle next
NODRV	LD	HL,ERRDRV
	DB	22H		;mangle next
NOOVER	LD	HL,ERROVER
	DB	22H		;mangle next
NOLDOS	LD	HL,ERRLDOS
	DB	22H		;mangle next
NOSYS0	LD	HL,ERRSYS0
	DB	22H		;mangle next
NOLONG	LD	HL,ERRLONG
	DB	22H		;mangle next
NOOWNER	LD	HL,ERRGAT
	DB	22H		;mangle next
NOMOD1	LD	HL,ERRIII
	CALL	@LOGOT
	JP	@ABORT
;
FNAME	DB	'SYS0    SYS'
;
;messages needed after the buffer is overwritten
RESULT	DB	'SYS0/SYS is now all on side 0',3
ERRGAT	DB	'Error, bad directory (GAT mismatch)!',13
ERRLONG	DB	'Error, bad SYS0/SYS!',13
ERROVER	DB	'Error, SYS0/SYS is correctly placed!',13
ERRLDOS	DB	'Error, must be LDOS 5.3.1!',13
ERRSYS0	DB	'Error, must contain SYS0/SYS!',13
;buffer area overwritten during operation
;to ease use of the buffer allign up to divisible by 100h
BUFFER	EQU	$+0FFH&0FF00H
SPLASH	DB	'TWOSIDER utility for creating'
	DB	' bootable DSSD floppies',10
	DB	'Copyright (c) 2003 Knut Roll-Lund',13
ERRIII	DB	'Error, for Model I only!',13
ERRDRV	DB	'Error, drive spec required!',13
ERRWRT	DB	'Error, drive is write protected!',13
ERRMINI	DB	'Error, drive is not a minifloppy!',13
ERRDS	DB	'Error, must be dual sided!',13
ERRDD	DB	'Error, must be single density!',13
;
	END	START
